From f9678516ea46277d45069eb7fd8400d656971109 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 2 Nov 2012 15:43:35 -0400
Subject: [PATCH] Updated icon-software.gif paths.

---
 .../shared/webapps/ca/admin/ca/securitydomainlogin.template |   2 +-
 .../common-ui/shared/admin/console/config/config_addhsm.vm  |   2 +-
 dogtag/common-ui/shared/admin/console/config/login.vm       |   2 +-
 .../shared/admin/console/config/securitydomainloginpanel.vm |   2 +-
 dogtag/common-ui/shared/admin/console/config/wizard.vm      |   2 +-
 .../images/{pki-icon-software.gif => icon-software.gif}     | Bin
 .../shared/docroot/ra/admin/console/config/config_addhsm.vm |   2 +-
 .../shared/docroot/ra/admin/console/config/config_db.vm     |   2 +-
 .../shared/docroot/ra/admin/console/config/config_hsm.vm    |   2 +-
 .../shared/docroot/ra/admin/console/config/config_join.vm   |   2 +-
 .../shared/docroot/ra/admin/console/config/config_rootca.vm |   2 +-
 .../ra-ui/shared/docroot/ra/admin/console/config/login.vm   |   2 +-
 .../ra/admin/console/config/securitydomainloginpanel.vm     |   2 +-
 .../ra-ui/shared/docroot/ra/admin/console/config/wizard.vm  |   2 +-
 .../img/{pki-icon-software.gif => icon-software.gif}        | Bin
 .../docroot/tps/admin/console/config/config_addhsm.vm       |   2 +-
 .../shared/docroot/tps/admin/console/config/config_db.vm    |   2 +-
 .../shared/docroot/tps/admin/console/config/config_hsm.vm   |   2 +-
 .../shared/docroot/tps/admin/console/config/config_join.vm  |   2 +-
 .../docroot/tps/admin/console/config/config_rootca.vm       |   2 +-
 .../tps-ui/shared/docroot/tps/admin/console/config/login.vm |   2 +-
 .../tps/admin/console/config/securitydomainloginpanel.vm    |   2 +-
 .../shared/docroot/tps/admin/console/config/wizard.vm       |   2 +-
 .../img/{pki-icon-software.gif => icon-software.gif}        | Bin
 24 files changed, 21 insertions(+), 21 deletions(-)
 rename dogtag/ra-ui/shared/docroot/images/{pki-icon-software.gif => icon-software.gif} (100%)
 rename dogtag/ra-ui/shared/docroot/ra/admin/console/img/{pki-icon-software.gif => icon-software.gif} (100%)
 rename dogtag/tps-ui/shared/docroot/tps/admin/console/img/{pki-icon-software.gif => icon-software.gif} (100%)

diff --git a/dogtag/ca-ui/shared/webapps/ca/admin/ca/securitydomainlogin.template b/dogtag/ca-ui/shared/webapps/ca/admin/ca/securitydomainlogin.template
index 6ffa70ec1f37b2063df8621abcebe00808edabd8..2b4734fd220945a354d81f2c35c9685dd8b5d274 100644
--- a/dogtag/ca-ui/shared/webapps/ca/admin/ca/securitydomainlogin.template
+++ b/dogtag/ca-ui/shared/webapps/ca/admin/ca/securitydomainlogin.template
@@ -54,7 +54,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="/ca/admin/console/img/rhn-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
 <script language=javascript>
 document.write('Security Domain ('+result.header.sdname+') Login </h1>');
 </script>
diff --git a/dogtag/common-ui/shared/admin/console/config/config_addhsm.vm b/dogtag/common-ui/shared/admin/console/config/config_addhsm.vm
index a670dc12f5239f80e5e66aa57f32fea62e600110..b2d03417c6ace6bc37c5b649d02184aa3ca7edba 100644
--- a/dogtag/common-ui/shared/admin/console/config/config_addhsm.vm
+++ b/dogtag/common-ui/shared/admin/console/config/config_addhsm.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td class="page-content" width="100%">
-  <h1><img src="../img/icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Modules</h1>
 Keys will be generated and stored on security modules. A security module can be hardware-based or software-based. Hardware-based security modules are more secure.
 <p>
diff --git a/dogtag/common-ui/shared/admin/console/config/login.vm b/dogtag/common-ui/shared/admin/console/config/login.vm
index 1646fe2d4f622c5c9ac699c6ffa05591afd5b2a7..246009c569e3ba9307bd199daf6d26260c186197 100644
--- a/dogtag/common-ui/shared/admin/console/config/login.vm
+++ b/dogtag/common-ui/shared/admin/console/config/login.vm
@@ -67,7 +67,7 @@
          
 	</td>
         <td class="page-content" width="100%">
-  <h1><img src="../img/icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Login</h1>
 
 A one time random pin has been generated during setup to protect unauthorized access to this configuration wizard. This pin has been stored in the "CS.cfg" configuration file as the value of the 'preop.pin' parameter. Please enter this pin to continue.
diff --git a/dogtag/common-ui/shared/admin/console/config/securitydomainloginpanel.vm b/dogtag/common-ui/shared/admin/console/config/securitydomainloginpanel.vm
index 46ff12b865a33ab5b0d23aa9f7411092a8d79385..e9234b5d7c885ac4dd421c51ee9d3a033c4773f3 100644
--- a/dogtag/common-ui/shared/admin/console/config/securitydomainloginpanel.vm
+++ b/dogtag/common-ui/shared/admin/console/config/securitydomainloginpanel.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="/ca/admin/console/img/icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Domain ($name) Login </h1>
 
     <form name=sdForm action="getCookie" method="post">
diff --git a/dogtag/common-ui/shared/admin/console/config/wizard.vm b/dogtag/common-ui/shared/admin/console/config/wizard.vm
index 81a8fb27ef48e7a9aa7b584bfbad91627b3c2feb..730ed25a3415e34644173ae0394434ff8c05ef84 100644
--- a/dogtag/common-ui/shared/admin/console/config/wizard.vm
+++ b/dogtag/common-ui/shared/admin/console/config/wizard.vm
@@ -103,7 +103,7 @@ function process(fop) {
 
 	</td>
         <td class="page-content" width="100%">
-  <h1><img alt="" src="../img/icon-software.gif" />
+  <h1><img alt="" src="/pki/images/icon-software.gif" />
   $title </h1>
 
 <OBJECT classid="clsid:127698E4-E730-4E5C-A2b1-21490A70C8A1"
diff --git a/dogtag/ra-ui/shared/docroot/images/pki-icon-software.gif b/dogtag/ra-ui/shared/docroot/images/icon-software.gif
similarity index 100%
rename from dogtag/ra-ui/shared/docroot/images/pki-icon-software.gif
rename to dogtag/ra-ui/shared/docroot/images/icon-software.gif
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_addhsm.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_addhsm.vm
index 9e0471d47120352d34dc4acc82aa7b7fdb38ff6b..8912d8f6fad8333ba37973e13068830cd3db3076 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_addhsm.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_addhsm.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td class="page-content" width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Modules</h1>
 Keys will be generated and stored on security modules. A security module can be hardware-based or software-based. Hardware-based security modules are more secure.
 <p>
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_db.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_db.vm
index 70ace4faff4fba8248d30a8aea7652af52fda876..5aa147ec19fb5ead0a7815c4b344c4caeefbff19 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_db.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_db.vm
@@ -57,7 +57,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Internal Database </h1>
 
     <form name=configForm action="config_db" method="post">
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_hsm.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_hsm.vm
index cc4cd8b6c26f9745f655ed7d74a64a0d37e43ef9..dbe8da657d481104ffab2b26d24813255f32d6be 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_hsm.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_hsm.vm
@@ -56,7 +56,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Modules </h1>
 
 <form name=configForm action="config_hsm" method="post">
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_join.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_join.vm
index d8b5dfcb15a850a82d2a1f3261cae39aaf2d213d..7dd4a68b72ab2efa5f6fe6165057daf4d00424a0 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_join.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_join.vm
@@ -56,7 +56,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Join the PKI Network </h1>
 
 To join this PKI network, the setup wizard needs to submit the certificate request to a Root or another subordinate CA for signing.
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_rootca.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_rootca.vm
index 9163f564c09dd5678e7c258508b0882862dcf05e..a65e54b79722b5221f7f68ae5ac1ee4a1a770069 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_rootca.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/config_rootca.vm
@@ -56,7 +56,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Root CA </h1>
 
 A Root CA provides a set of predefined signing capabilities. Please select the capabilities that this CA needs to provide.
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/login.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/login.vm
index 9595783b7ecfea903df9a201ccd4096bc620de8b..daaf70c08ff378cf3693ead980fb8a80c9e64809 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/login.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/login.vm
@@ -65,7 +65,7 @@
          
 	</td>
         <td class="page-content" width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Login</h1>
 
 A one time random pin has been generated during setup to protect unauthorized access to this configuration wizard. This pin has been stored in the "CS.cfg" configuration file as the value of the 'preop.pin' parameter. Please enter this pin to continue.
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/securitydomainloginpanel.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/securitydomainloginpanel.vm
index 2557616ceaf7d1443fd3d3b46a318a96670b8005..bbe9c846841978260f42f5394496a2420555e40d 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/securitydomainloginpanel.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/securitydomainloginpanel.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="/ca/admin/console/img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Domain ($name) Login </h1>
 
     <form name=sdForm action="getCookie" method="post">
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/wizard.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/wizard.vm
index bab26b970ac1259080440066f0c895a28cd01491..b0ec3e9128abe98a81d8f4b0c89002e03ef48f89 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/wizard.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/wizard.vm
@@ -100,7 +100,7 @@ function process(fop) {
 
 	</td>
         <td class="page-content" width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   $title </h1>
 
 <form name=f method=post action="wizard">
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/img/pki-icon-software.gif b/dogtag/ra-ui/shared/docroot/ra/admin/console/img/icon-software.gif
similarity index 100%
rename from dogtag/ra-ui/shared/docroot/ra/admin/console/img/pki-icon-software.gif
rename to dogtag/ra-ui/shared/docroot/ra/admin/console/img/icon-software.gif
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_addhsm.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_addhsm.vm
index 8e22d5470755ed4f5ba98f6aaa8c5cd9f7494a4e..21fc1620d779c7d66f318bdd276b8dd2cc13368a 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_addhsm.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_addhsm.vm
@@ -54,7 +54,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td class="page-content" width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Modules</h1>
 Keys will be generated and stored on security modules. A security module can be hardware-based or software-based. Hardware-based security modules are more secure.
 <p>
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_db.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_db.vm
index 2ceb928c20b882a0bc016108407811810354948a..d09c8c22b16a47ecdd967d0cf21dd19e2ac6f005 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_db.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_db.vm
@@ -56,7 +56,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Internal Database </h1>
 
     <form name=configForm action="config_db" method="post">
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_hsm.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_hsm.vm
index e6b3e0e1813da64101a8f334b4c2d0dd07332d62..115e70d4eabe8b6e0290156d02634068a2c700e7 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_hsm.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_hsm.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Modules </h1>
 
 <form name=configForm action="config_hsm" method="post">
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_join.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_join.vm
index 71c26bdb3237ca136fdf4f87d962d05ea4f87064..9868ecae26245f94d661d5dc492afd75956a3556 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_join.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_join.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Join the PKI Network </h1>
 
 To join this PKI network, the setup wizard needs to submit the certificate request to a Root or another subordinate CA for signing.
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_rootca.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_rootca.vm
index 4e85a2077f1e90b436065d6f323b627f3e7f3834..0d185c82cb2c47233771074614ab5231c856372a 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_rootca.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/config_rootca.vm
@@ -55,7 +55,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Root CA </h1>
 
 A Root CA provides a set of predefined signing capabilities. Please select the capabilities that this CA needs to provide.
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/login.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/login.vm
index 97cec6320c1c0a2a8214a1d10064ae531a3b1cfc..fcccc508ebf7d91398cd36d848865427f91f27e0 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/login.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/login.vm
@@ -64,7 +64,7 @@
          
 	</td>
         <td class="page-content" width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Login</h1>
 
 A one time random pin has been generated during setup to protect unauthorized access to this configuration wizard. This pin has been stored in the "CS.cfg" configuration file as the value of the 'preop.pin' parameter. Please enter this pin to continue.
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/securitydomainloginpanel.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/securitydomainloginpanel.vm
index 47462d773a104019466749c099df1995165a0df5..4bde4aa79b5f385678a9401490f26960eb31ccb3 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/securitydomainloginpanel.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/securitydomainloginpanel.vm
@@ -54,7 +54,7 @@
     <table width="100%" cellspacing="0">
       <tr>
         <td width="100%">
-  <h1><img src="/ca/admin/console/img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   Security Domain ($name) Login </h1>
 
     <form name=sdForm action="getCookie" method="post">
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/wizard.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/wizard.vm
index db454e90e0b5e155a13fd09104c47b0614c30872..4b887144e1489bc66918f5ee8479ce9949768213 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/wizard.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/wizard.vm
@@ -103,7 +103,7 @@ function process(fop) {
 
 	</td>
         <td class="page-content" width="100%">
-  <h1><img src="../img/pki-icon-software.gif" />
+  <h1><img src="/pki/images/icon-software.gif" />
   $title </h1>
 
 <form name=f method=post action="wizard">
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/img/pki-icon-software.gif b/dogtag/tps-ui/shared/docroot/tps/admin/console/img/icon-software.gif
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/tps/admin/console/img/pki-icon-software.gif
rename to dogtag/tps-ui/shared/docroot/tps/admin/console/img/icon-software.gif
-- 
1.7.12.1